"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withStaticContext = withStaticContext;

function isRuleSetUseItem(useItem) {
  return !!useItem.loader;
}

function findNextBabelRule(config) {
  var _config$module, _config$module$rules;

  return (_config$module = config.module) === null || _config$module === void 0 ? void 0 : (_config$module$rules = _config$module.rules) === null || _config$module$rules === void 0 ? void 0 : _config$module$rules.find(rule => {
    var _rule$use, _rule$use2, _rule$use2$loader;

    if (typeof rule === 'string' || typeof rule.use === 'string' || typeof rule.use === 'function') {
      return false;
    }

    if (Array.isArray(rule.use)) {
      return rule.use.some(useItem => {
        if (isRuleSetUseItem(useItem)) {
          var _useItem$loader;

          return useItem.loader === 'next-babel-loader' || ((_useItem$loader = useItem.loader) === null || _useItem$loader === void 0 ? void 0 : _useItem$loader.includes('babel/loader'));
        }

        return false;
      });
    }

    return ((_rule$use = rule.use) === null || _rule$use === void 0 ? void 0 : _rule$use.loader) === 'next-babel-loader' || ((_rule$use2 = rule.use) === null || _rule$use2 === void 0 ? void 0 : (_rule$use2$loader = _rule$use2.loader) === null || _rule$use2$loader === void 0 ? void 0 : _rule$use2$loader.includes('babel/loader'));
  });
}

function withStaticContext(nextConfig = {}) {
  return { ...nextConfig,

    webpack(config, options) {
      const {
        isServer
      } = options;
      const nextBabelRule = findNextBabelRule(config);

      if (!nextBabelRule || typeof nextBabelRule === 'string') {
        return config;
      }

      const loader = require.resolve('./webpack/next-static-context-loader');

      if (Array.isArray(nextBabelRule.use)) {
        nextBabelRule.use.unshift({
          loader,
          options: {
            isServer
          }
        });
      } else {
        nextBabelRule.use = [{
          loader,
          options: {
            isServer
          }
        }, nextBabelRule.use];
      }

      if (typeof nextConfig.webpack === 'function') {
        return nextConfig.webpack(config, options);
      }

      return config;
    }

  };
}